#!/usr/bin/python
# Simple level editor... turns textfile into things.
# It's boundry zone algorithm isnt' very effecent.

# Expects a 19-row by 50-collumn block of text on it's stdin.
# This is a matrix of the level. Letters are as follows:
# (space): Empty Space
# .: Block
# ,: Wall (Industrictable wall.)
# -, | - Big walls. (Extend four places to the right or downward, respectivley.)
# 1-4: Player incarnator
# s: shield yummie (20 point)
# S: Shield yummie, (100 point)
# z: Speed yummie.
# r: Rockets 	p: Protons	l: floatie
# m: Mines	d: Drones	b: blocks
# f: Flack	n: Nades	e: Defecltor
# 5,7: Teleporter begins
# 6,8: Teleporter ends
# ] > ) }: Teleporters end points
# ^: Rubble (1 point)

from sys import stdin, stdout, argv 
boundoff = (len(argv) > 1 and argv[1].replace(' ','') == 'boundless')
lines = stdin.readlines()
from random import randint
print lines[0]
	
n = True
incarnators = {}
markers = {}
y = 0
for line in lines[1:]:
	bbound = -32
	x = 0
	if line[0] == '$':
		print line[1:].replace(';','\n')
		continue
	for c in line:
		if c == ' ' and not n: n = not n; continue # Skip odd collumns
		elif c == ' ' and bbound and not boundoff:
			print "bound %d %d %d %d"%(bbound, y, x, y+32 )
			bbound = None
		if c == '.':
			print "block %d %d 0"%(x,y)
			if not bbound: bbound = x
		elif c == '\'':
			print "gblock %d %d 0 0"%(x,y)
			if not bbound: bbound = x
		elif c == ',':
			print "wall %d %d 0"%(x,y)
			if not bbound: bbound = x
		elif c == ';':
			print "tblock %d %d 500"%(x,y)
			if not bbound: bbound = x
		elif c == '"':
			print "barea %d %d -600"%(x,y)
			if not bbound: bbound = x
		elif c == ':':
			print "tblock %d %d -600"%(x,y)
			if not bbound: bbound = x
		elif c == '-':
			print "wall %d %d 2"%(x,y)
			print "bound %d %d %d %d"%(x,y,x+128,y+32)
		elif c == '|':
			print "wall %d %d 1"%(x,y)
			print "bound %d %d %d %d"%(x,y,x+32,y+128)
		elif c == 'z':
			print "item %d %d 0"%(x+4,y+4)
		elif c == 'g':
			print "item %d %d -101"%(x+4,y+4)
		elif c == 'b':
			print "item %d %d 8"%(x+4,y+4)
		elif c == 'l':
			print "item %d %d 9"%(x+4,y+4)
		elif c == 's':
			print "item %d %d -20"%(x+4,y+4)
		elif c == 'd':
			print "item %d %d 5"%(x+4,y+4)
		elif c == 'S':
			print "item %d %d -100"%(x+4,y+4)
		elif c == 'r':
			print "item %d %d 1"%(x+4,y+4)
		elif c == 'f':
			print "item %d %d 3 # floatie"%(x+4,y+4)
		elif c == 'n':
			print "item %d %d 10 # nanites"%(x+4,y+4)
		elif c == 'a':
			print "item %d %d 6"%(x+4,y+4)
		elif c == 'e':
			print "item %d %d 7"%(x+4,y+4)
		elif c == 'm':
			print "item %d %d 2"%(x+4,y+4)
		elif c == 'M': # Armed mine
			print "weap %d %d 2 0 0"%(x+8,y+8)
		elif c == 'p':
			print "item %d %d 4"%(x+4,y+4)
		elif c == '*':
			print "ball %d %d"%(x,y)
		elif c == '@':
			print "pill %d %d"%(x,y)
		elif c == '?':
			print "# Marker (%d, %d)"%(x,y)
		elif c.isdigit() and int(c) > 4:
			d = int(c)
			if d%2:
				if markers.has_key(d-5):
					markers[d-5].append((x,y))
				else:
					markers[d-5] = [(x,y)]
			else:
				markers[d-5] = x,y
		elif c.isdigit():
			incarnators[int(c)] = x,y	
		x += 32
		n = not n
	if bbound and not boundoff:
		print "bound %d %d %d %d"%(bbound, y, x, y+32 )
		bbound = None
	y += 32
if bbound and not boundoff:
	print "bound %d %d %d %d"%(bbound, y, x, y+32 )
	
print "\n"

for key, value in incarnators.items():
	print "spawn %d %d %d"%(value+(key,))
#print markers, len(markers)
i = 0
while i < len(markers):
	for tele in markers[i]:
		print "tele %d %d %d %d"%(tele[0],tele[1],markers[i+1][0],markers[i+1][1])
	i += 2
