from pygame import image
Blocks = [
	image.load('Data/Sprites/Block.png').convert()
	]

TBlock = [
	image.load('Data/Sprites/TBlock.png').convert()
	]
BArea = [
	image.load('Data/Sprites/BArea.png').convert_alpha()
	]

Walls = [
	image.load('Data/Sprites/Wall.png').convert(),
	image.load('Data/Sprites/BigWallV.png').convert(),
	image.load('Data/Sprites/BigWallH.png').convert()
	]

Pill = [image.load('Data/Sprites/Pill.png').convert_alpha()]
PillShot = [image.load('Data/Sprites/Pillshot.png').convert_alpha(),
	image.load('Data/Sprites/Pillshot2.png').convert_alpha(),
	image.load('Data/Sprites/Pillshot3.png').convert_alpha()
	]
Pepper = [image.load('Data/Sprites/pepper1.png').convert_alpha()]

Items = [
	image.load('Data/Sprites/Yummie-Shield.png').convert_alpha(),
	image.load('Data/Sprites/Yummie-Speed.png').convert_alpha(),
	image.load('Data/Sprites/Yummie-Weapon(rocket).png').convert_alpha(),
	image.load('Data/Sprites/Yummie-Weapon(mine).png').convert_alpha(),
	image.load('Data/Sprites/Yummie-Weapon(flak).png').convert_alpha(),
	image.load('Data/Sprites/Yummie-Weapon(protons).png').convert_alpha(),
	image.load('Data/Sprites/Yummie-Weapon(drone).png').convert_alpha(),
	image.load('Data/Sprites/Yummie-Weapon(nade).png').convert_alpha(),
	image.load('Data/Sprites/Yummie-Weapon(shield).png').convert_alpha(),
	image.load('Data/Sprites/Yummie-Weapon(blocks).png').convert_alpha(),
	image.load('Data/Sprites/Yummie-Floatie.png').convert_alpha(),
	image.load('Data/Sprites/Yummie-Nano.png').convert_alpha(),
	image.load('Data/Sprites/Yummie-Weapon(polarmine).png').convert_alpha(),
	image.load('Data/Sprites/Yummie-NanoSpread.png').convert_alpha(),
	image.load('Data/Sprites/Yummie-Weapon(goober).png').convert_alpha(),
	]
PlayerExplode = [
	image.load('Data/Sprites/Player-Die1.png').convert_alpha(),
	image.load('Data/Sprites/Player-Die2.png').convert_alpha(),
	image.load('Data/Sprites/Player-Die3.png').convert_alpha(),
	image.load('Data/Sprites/Player-Die4.png').convert_alpha(),
	image.load('Data/Sprites/Player-Die5.png').convert_alpha(),
	image.load('Data/Sprites/Player-Die6.png').convert_alpha(),
	image.load('Data/Sprites/Player-Die7.png').convert_alpha()
	]

Gorgon = [
	image.load('Data/Sprites/Gorgon1.png'),#.convert_alpha()
	image.load('Data/Sprites/Gorgon2.png'),#.convert_alpha()
	image.load('Data/Sprites/Gorgon3.png'),#.convert_alpha()
	image.load('Data/Sprites/Gorgon4.png')#.convert_alpha()
	]
Switch = [
	image.load('Data/Sprites/SBlockOff.png'),#.convert_alpha()
	image.load('Data/Sprites/SBlockOn.png'),#.convert_alpha()
	]

NilImg = image.load('Data/Sprites/Nil.png').convert()

def i(n):
	return image.load('Data/Sprites/Player'+n+'.png').convert_alpha()


Players = [
	
	[
		[[i('1-UL-O'),i('1-UL-E')],[i('1-L-O'),i('1-L-E')],[i('1-DL-O'),i('1-DL-E')]], # lEFT (UP nov DOWN)
		[[i('1-U-O'),i('1-U-E')],[i('1-U-O'),i('1-U-E') ],[i('1-D-O'),i('1-D-E')]], #noh ( UP nov DOWN)
		[[i('1-UR-O'),i('1-UR-E')],[i('1-R-O'),i('1-R-E')],[i('1-DR-O'),i('1-DR-E')]]#  right (UP nov DOWN)
	], # Player 1
	[
		[[i('2-UL-O'),i('2-UL-E')],[i('2-L-O'),i('2-L-E')],[i('2-DL-O'),i('2-DL-E')]], # lEFT (UP nov DOWN)
		[[i('2-U-O'),i('2-U-E')],[i('2-U-O'),i('2-U-E') ],[i('2-D-O'),i('2-D-E')]], #noh ( UP nov DOWN)
		[[i('2-UR-O'),i('2-UR-E')],[i('2-R-O'),i('2-R-E')],[i('2-DR-O'),i('2-DR-E')]]#  right (UP nov DOWN)
	], # Player 2
	[
		[[i('3-UL-O'),i('3-UL-E')],[i('3-L-O'),i('3-L-E')],[i('3-DL-O'),i('3-DL-E')]], # lEFT (UP nov DOWN)
		[[i('3-U-O'),i('3-U-E')],[i('3-U-O'),i('3-U-E') ],[i('3-D-O'),i('3-D-E')]], #noh ( UP nov DOWN)
		[[i('3-UR-O'),i('3-UR-E')],[i('3-R-O'),i('3-R-E')],[i('3-DR-O'),i('3-DR-E')]]#  right (UP nov DOWN)
	], # Player 3
	[
		[[i('4-UL-O'),i('4-UL-E')],[i('4-L-O'),i('4-L-E')],[i('4-DL-O'),i('4-DL-E')]], # lEFT (UP nov DOWN)
		[[i('4-U-O'),i('4-U-E')],[ i('4-U-O'),i('4-U-E') ],[i('4-D-O'),i('4-D-E')]], #noh ( UP nov DOWN)
		[[i('4-UR-O'),i('4-UR-E')],[i('4-R-O'),i('4-R-E')],[i('4-DR-O'),i('4-DR-E')]]#  right (UP nov DOWN)
	] # Player 4
	]

#	]
#		[[ ULO,ULE ], [LO,LE] ,[ DLO,DLE ]], # lEFT (UP nov DOWN)
#		[[ UO,UE ], [None,None] ,[ DO,DE ]], #noh ( UP nov DOWN)
#		[[ URO,URE ], [RO,RE] ,[ DRO,DRE ]]#  right (UP nov DOWN)
#	], # Player template

PlasmaShot = [
	image.load('Data/Sprites/Plasma.png').convert_alpha()
	]
TargetDot = [
	image.load('Data/Sprites/TargetA.png').convert(),
	image.load('Data/Sprites/Target.png').convert()
	]


PlasmaExplosion = [
	image.load('Data/Sprites/Plasma-Explode1.png').convert_alpha(),
	image.load('Data/Sprites/Plasma-Explode2.png').convert_alpha(),
	image.load('Data/Sprites/Plasma-Explode3.png').convert_alpha(),
	image.load('Data/Sprites/Plasma-Explode4.png').convert_alpha(),
	image.load('Data/Sprites/Plasma-Explode5.png').convert_alpha(),
	image.load('Data/Sprites/Plasma-Explode6.png').convert_alpha()
	]

Explosion = [
	image.load('Data/Sprites/Explosion1.png').convert_alpha(),
	image.load('Data/Sprites/Explosion2.png').convert_alpha(),
	image.load('Data/Sprites/Explosion3.png').convert_alpha(),
	image.load('Data/Sprites/Explosion4.png').convert_alpha(),
	image.load('Data/Sprites/Explosion5.png').convert_alpha()
	]

Shrapnel_Grey = [
	image.load('Data/Sprites/GShrap1.png').convert_alpha(),
	image.load('Data/Sprites/GShrap2.png').convert_alpha(),
	image.load('Data/Sprites/GShrap3.png').convert_alpha()
	]



Shrapnel_Purple = [
	image.load('Data/Sprites/PShrap1.png').convert_alpha(),
	image.load('Data/Sprites/PShrap2.png').convert_alpha(),
	image.load('Data/Sprites/PShrap3.png').convert_alpha()
	]

Goober = [
	image.load('Data/Sprites/goober1.png').convert_alpha(),
	image.load('Data/Sprites/goober2.png').convert_alpha(),
	image.load('Data/Sprites/goober3.png').convert_alpha()
	]

Flak = [
	image.load('Data/Sprites/Flak.png').convert_alpha()
	]
GorgonItem = image.load('Data/Sprites/Yummie-Gorgon.png').convert_alpha()	
Rocket = [
	#Left
	[image.load('Data/Sprites/RocketLU.png').convert_alpha(),
	image.load('Data/Sprites/RocketL.png').convert_alpha(),
	image.load('Data/Sprites/RocketDL.png').convert_alpha()], # Up, no verticle, down
	
	#No horizontal
	[image.load('Data/Sprites/RocketU.png').convert_alpha(),
	None,
	image.load('Data/Sprites/RocketD.png').convert_alpha()], # Up, no verticle, down	
	# Right
	[image.load('Data/Sprites/RocketRU.png').convert_alpha(),
	image.load('Data/Sprites/RocketR.png').convert_alpha(),
	image.load('Data/Sprites/RocketDR.png').convert_alpha()], # Up, no verticle, down
	]

Mine = [
	image.load('Data/Sprites/Mine.png').convert_alpha(),
	]
PMine = [
	image.load('Data/Sprites/PolarMine.png').convert_alpha(),
]


Drone = [
	image.load('Data/Sprites/Drone1.png').convert_alpha(),
	image.load('Data/Sprites/Drone2.png').convert_alpha(),
	image.load('Data/Sprites/Drone3.png').convert_alpha(),
	image.load('Data/Sprites/Drone4.png').convert_alpha()
	]

PolaronExplode = [
	image.load('Data/Sprites/Polaron1.png').convert_alpha(),
	image.load('Data/Sprites/Polaron2.png').convert_alpha(),
	image.load('Data/Sprites/Polaron3.png').convert_alpha(),
	image.load('Data/Sprites/Polaron4.png').convert_alpha(),
	image.load('Data/Sprites/Polaron5.png').convert_alpha(),
	image.load('Data/Sprites/Polaron6.png').convert_alpha(),
	image.load('Data/Sprites/Polaron7.png').convert_alpha()
	]

Polaron = [
	image.load('Data/Sprites/PolaronBurst.png').convert_alpha()
	]
SubPolaron = [
	image.load('Data/Sprites/SubPolaronBurst.png').convert_alpha()
	]

Seeker = [
	[image.load('Data/Sprites/Seeker1U.png').convert_alpha(),
	image.load('Data/Sprites/Seeker1A.png').convert_alpha()],
	[image.load('Data/Sprites/Seeker2U.png').convert_alpha(),
	image.load('Data/Sprites/Seeker2A.png').convert_alpha()],
	[image.load('Data/Sprites/Seeker3U.png').convert_alpha(),
	image.load('Data/Sprites/Seeker3A.png').convert_alpha()],
	[image.load('Data/Sprites/Seeker4U.png').convert_alpha(),
	image.load('Data/Sprites/Seeker4A.png').convert_alpha()]
	]

Tele = [
	image.load('Data/Sprites/Tele1.png'),
	image.load('Data/Sprites/Tele2.png'),
	image.load('Data/Sprites/Tele3.png'),
	image.load('Data/Sprites/Tele4.png'),
	image.load('Data/Sprites/Tele5.png'),
	image.load('Data/Sprites/Tele6.png')
	]

PortFlash = [ 
	image.load('Data/Sprites/Telport1.png'),
	image.load('Data/Sprites/Telport2.png'),
	image.load('Data/Sprites/Telport3.png'),
	image.load('Data/Sprites/Telport4.png')
	]

MobileBlock = [
	image.load('Data/Sprites/MBlock.png')
	]

GBlock = [
	image.load('Data/Sprites/GBlock1.png'),
	image.load('Data/Sprites/GBlock2.png'),
	image.load('Data/Sprites/GBlock3.png'),
	image.load('Data/Sprites/GBlock4.png'),
	image.load('Data/Sprites/GBlock5.png'),
	image.load('Data/Sprites/GBlock6.png'),
	image.load('Data/Sprites/GBlock7.png'),
	image.load('Data/Sprites/GBlock8.png'),
	image.load('Data/Sprites/GBlock9.png')
	]

Shield = [
	image.load('Data/Sprites/Shield.png')
	]

Floatie = [
	image.load('Data/Sprites/BumpieField.png')
	]
def g(n):
	return image.load('Data/Sprites/Gorgon-Shot'+n+'.png')

FingerOfGorgon = [
	[
	[g('UL1'),g('UL2'),g('UL3')], [None], [g('DL1'),g('DL2'),g('DL3')]
	], # Left
	
	    [None], # Nil
	
	[
	[g('UR1'),g('UR2'),g('UR3')], [None], [g('DR1'),g('DR2'),g('DR3')]
	]  # Right
	]
